| Disk ARchive 2.7.12 Full featured and portable backup and archiving tool

Public Member Functions | Protected Member Functions | Private Types | Private Member Functions | Private Attributes | List of all members
libdar::tuyau Class Reference
Private

pipe implementation under the generic_file interface. More...

`#include <tuyau.hpp>`

Inherits libdar::generic_file, libdar::thread_cancellation, and libdar::mem_ui.

## Public Member Functions
| tuyau (const std::shared_ptr< user_interaction > &dialog, int fd)
| tuyau (const std::shared_ptr< user_interaction > &dialog, int fd, gf_mode mode)
| tuyau (const std::shared_ptr< user_interaction > &dialog, const std::string &filename, gf_mode mode)
| tuyau (const std::shared_ptr< user_interaction > &dialog)
| creates a anonymous pipe and bind itself to the writing end. The reading end can be obtained by get_read_side() method
| tuyau (const tuyau &ref)=default
| tuyau (tuyau &&ref) noexcept=default
tuyau & | operator= (const tuyau &ref)=default
tuyau & | operator= (tuyau &&ref) noexcept=default
int | get_read_fd () const
void | close_read_fd ()
| closes the read fd of the anonymous pipe (this is to be used by a writer) More...
void | do_not_close_read_fd ()
| ask to not close the read descriptor upon object destruction (the fd survives the object)
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip More...
virtual bool | skip (const infinint &pos) override
| skip at the absolute position More...
virtual bool | skip_to_eof () override
| skip to the end of file More...
virtual bool | skip_relative (signed int x) override
virtual bool | truncatable (const infinint &pos) const override
| whether the implementation is able to truncate to the given position More...
virtual infinint | get_position () const override
| get the current read/write position More...
bool | has_next_to_read ()
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor More...
| generic_file (const generic_file &ref)
| copy constructor More...
| generic_file (generic_file &&ref) noexcept
| move constructor More...
generic_file & | operator= (const generic_file &ref)
| assignment operator More...
generic_file & | operator= (generic_file &&ref) noexcept
| move operator More...
| ~generic_file () noexcept(false)
| virtual destructor, More...
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object More...
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file More...
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file More...
void | write (const std::string &arg)
| write a string to the generic_file More...
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char More...
virtual bool | skippable (skippability direction, const infinint &amount)=0
| whether the implementation is able to skip More...
virtual bool | skip (const infinint &pos)=0
| skip at the absolute position More...
virtual bool | skip_to_eof ()=0
| skip to the end of file More...
virtual bool | skip_relative (S_I x)=0
| skip relatively to the current position More...
virtual bool | truncatable (const infinint &pos) const =0
| whether the implementation is able to truncate to the given position More...
virtual void | truncate (const infinint &pos)
| truncate file at the given offset More...
virtual infinint | get_position () const =0
| get the current read/write position More...
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument More...
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data More...
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument More...
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data More...
bool | crc_status () const
| to known whether CRC calculation is activated or not More...
crc * | get_crc ()
| get CRC of the transfered date since last reset More...
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor More...
virtual U_I | read (char *a, U_I size)=0
| read data from the proto_generic_file More...
virtual void | write (const char *a, U_I size)=0
| write data to the proto_generic_file More...
Public Member Functions inherited from libdar::thread_cancellation
| thread_cancellation ()
| the constructor
| thread_cancellation (const thread_cancellation &ref)=default
| copy constructor
| thread_cancellation (thread_cancellation &&ref) noexcept=default
| move constructor
thread_cancellation & | operator= (const thread_cancellation &ref)=default
| assignment operator
thread_cancellation & | operator= (thread_cancellation &&ref) noexcept=default
| move operator
virtual | ~thread_cancellation () noexcept(false)
| the destructor
void | check_self_cancellation () const
| Checkpoint test : whether the current libdar call must abort or not. More...
void | block_delayed_cancellation (bool mode)

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data More...
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation More...
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation More...
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset More...
virtual void | inherited_sync_write () override
| write down any pending data More...
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position More...
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions More...
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
virtual void | inherited_read_ahead (const infinint &amount)=0
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data More...
virtual U_I | inherited_read (char *a, U_I size)=0
| implementation of read() operation More...
virtual void | inherited_write (const char *a, U_I size)=0
| implementation of the write() operation More...
virtual void | inherited_truncate (const infinint &pos)=0
| truncate file at the give offset More...
virtual void | inherited_sync_write ()=0
| write down any pending data More...
virtual void | inherited_flush_read ()=0
| reset internal engine, flush caches in order to read the data at current position More...
virtual void | inherited_terminate ()=0
| destructor-like call, except that it is allowed to throw exceptions More...
bool | is_terminated () const
Protected Member Functions inherited from libdar::mem_ui
user_interaction & | get_ui () const
| get access to the user_interaction object More...
std::shared_ptr< user_interaction > | get_pointer () const
| get access to the shared_ptr pointing to the user_interaction More...
| mem_ui (const std::shared_ptr< user_interaction > &dialog)
| constructor More...
| mem_ui (const mem_ui &ref)=default
| the copy constructor More...
| mem_ui (mem_ui &&ref) noexcept=default
| the move constructor
mem_ui & | operator= (const mem_ui &ref)=default
| assignement operator More...
mem_ui & | operator= (mem_ui &&ref) noexcept=default
| move operator
virtual | ~mem_ui () noexcept(false)
| destructor More...

## Private Types
enum | { pipe_fd , pipe_path , pipe_both }

## Private Member Functions
void | ouverture ()
bool | read_and_drop (infinint byte)
| skip forward by reading data More...
bool | read_to_eof ()
| skip to eof by reading data

## Private Attributes
enum libdar::tuyau:: { ... } | pipe_mode
| defines how the object's status (which possible values defined by the anonymous enum above)
infinint | position
| recorded position in the stream More...
int | filedesc
| file descriptors of the pipe More...
int | other_end_fd
| in pipe_both mode, this holds the reading side of the anonymous pipe More...
std::string | chemin
| in pipe_path mode only, this holds the named pipe to be open More...
bool | has_one_to_read
| if true, the next char to read is placed in "next_to_read" More...
char | next_to_read
| when has_one_to_read is true, contains the next to read byte More...

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward }
Static Public Member Functions inherited from libdar::thread_cancellation
static U_I | count ()
| method for debugging/control purposes More...

## Detailed Description

pipe implementation under the generic_file interface.

Definition at line 48 of file tuyau.hpp.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| private

Enumerator
pipe_fd | holds a single file descriptor for the pipe
pipe_path | holds a filename to be openned (named pipe)
pipe_both | holds a pair of file descriptors

Definition at line 104 of file tuyau.hpp.

## Constructor & Destructor Documentation

## ◆ tuyau() [1/3]

libdar::tuyau::tuyau | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | int | fd
| ) |  |

Parameters

  dialog | for user interaction
  fd | fd is the filedescriptor of a pipe extremity already openned

## ◆ tuyau() [2/3]

libdar::tuyau::tuyau | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | int | fd,
|  | gf_mode | mode
| ) |  |

Parameters

  dialog | for user interaction
  fd | fd is the filedescriptor of a pipe extremity already openned
  mode | forces the mode if possible

## ◆ tuyau() [3/3]

libdar::tuyau::tuyau | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | const std::string & | filename,
|  | gf_mode | mode
| ) |  |

Parameters

  dialog | for user interaction
  filename | named pipe to open
  mode | forces the mode if possible

## Member Function Documentation

## ◆ close_read_fd()

void libdar::tuyau::close_read_fd | ( |  | ) |

closes the read fd of the anonymous pipe (this is to be used by a writer)

Note
  to ensure a proper behavior of the 'eof', the writer must close the read fd this call let this be done, assuming the read has already fetched the fd and forked in a new process

## ◆ get_position()

virtual infinint libdar::tuyau::get_position | ( |  | ) | const
| inline override virtual

get the current read/write position

Implements libdar::generic_file.

Definition at line 90 of file tuyau.hpp.

References position.

## ◆ get_read_fd()

int libdar::tuyau::get_read_fd | ( |  | ) | const

provides the reading end of the anonymous pipe when the current object has created it (no filedesc, no path given to constructor).

Note
  this methid cannot be called more than once.

## ◆ inherited_flush_read()

virtual void libdar::tuyau::inherited_flush_read | ( |  | ) |
| inline override protected virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 100 of file tuyau.hpp.

## ◆ inherited_read()

virtual U_I libdar::tuyau::inherited_read | ( | char * | a,
|  | U_I | size
| ) |  |
| override protected virtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

## ◆ inherited_read_ahead()

virtual void libdar::tuyau::inherited_read_ahead | ( | const infinint & | amount | ) |
| inline override protected virtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

Definition at line 95 of file tuyau.hpp.

## ◆ inherited_sync_write()

virtual void libdar::tuyau::inherited_sync_write | ( |  | ) |
| inline override protected virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 99 of file tuyau.hpp.

## ◆ inherited_terminate()

virtual void libdar::tuyau::inherited_terminate | ( |  | ) |
| override protected virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

## ◆ inherited_truncate()

virtual void libdar::tuyau::inherited_truncate | ( | const infinint & | pos | ) |
| inline override protected virtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

Definition at line 98 of file tuyau.hpp.

References position.

## ◆ inherited_write()

virtual void libdar::tuyau::inherited_write | ( | const char * | a,
|  | U_I | size
| ) |  |
| override protected virtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

## ◆ read_and_drop()

bool libdar::tuyau::read_and_drop | ( | infinint | byte | ) |
| private

skip forward by reading data

Parameters

  [in] | byte | is the amount of byte to skip forward

Returns
  true if the given amount of byte could be read, false otherwise (reached EOF).

## ◆ skip()

virtual bool libdar::tuyau::skip | ( | const infinint & | pos | ) |
| override virtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

## ◆ skip_to_eof()

virtual bool libdar::tuyau::skip_to_eof | ( |  | ) |
| override virtual

skip to the end of file

Implements libdar::generic_file.

## ◆ skippable()

virtual bool libdar::tuyau::skippable | ( | skippability | direction,
|  | const infinint & | amount
| ) |  |
| override virtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

## ◆ truncatable()

virtual bool libdar::tuyau::truncatable | ( | const infinint & | pos | ) | const
| inline override virtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

Definition at line 89 of file tuyau.hpp.

References position.

## Member Data Documentation

## ◆ chemin

std::string libdar::tuyau::chemin
| private

in pipe_path mode only, this holds the named pipe to be open

Definition at line 113 of file tuyau.hpp.

## ◆ filedesc

int libdar::tuyau::filedesc
| private

file descriptors of the pipe

Definition at line 111 of file tuyau.hpp.

## ◆ has_one_to_read

bool libdar::tuyau::has_one_to_read
| private

if true, the next char to read is placed in "next_to_read"

Definition at line 114 of file tuyau.hpp.

## ◆ next_to_read

char libdar::tuyau::next_to_read
| private

when has_one_to_read is true, contains the next to read byte

Definition at line 115 of file tuyau.hpp.

## ◆ other_end_fd

int libdar::tuyau::other_end_fd
| private

in pipe_both mode, this holds the reading side of the anonymous pipe

Definition at line 112 of file tuyau.hpp.

## ◆ position

infinint libdar::tuyau::position
| private

recorded position in the stream

Definition at line 110 of file tuyau.hpp.

Referenced by get_position(), inherited_truncate(), and truncatable().

The documentation for this class was generated from the following file:

- tuyau.hpp